FinalProjectTBI/FinalProjectTBI/Controllers/ClosedAppsController.cs
using FinalProjectTBI.Data.Models;
using FinalProjectTBI.Services.Contracts;
using FinalProjectTBI.Web.Models;
using FinalProjectTBI.Web.Models.EmailViewModels;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace FinalProjectTBI.Web.Controllers
{
    public class ClosedAppsController : Controller
    {
        private readonly ILoanApplicationService loanApplicationService;
        private readonly ILoanApplicantService loanApplicantService;
        private readonly IEmailService emailService;
        private readonly IViewModelMapper<ReceivedEmail, EmailViewModel> emailMapper;

        public ClosedAppsController(
            ILoanApplicationService loanApplicationService,
            ILoanApplicantService loanApplicantService,
            IEmailService emailService,
            IViewModelMapper<ReceivedEmail, EmailViewModel> emailMapper
            )
        {
            this.loanApplicationService = loanApplicationService ?? throw new ArgumentNullException(nameof(loanApplicationService));
            this.loanApplicantService = loanApplicantService ?? throw new ArgumentNullException(nameof(loanApplicantService));
            this.emailService = emailService ?? throw new ArgumentNullException(nameof(emailService));
            this.emailMapper = emailMapper ?? throw new ArgumentNullException(nameof(emailMapper));
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> ListClosedEmails()
        {
            var draw = Request.Form["draw"].FirstOrDefault();
            var start = Request.Form["start"].FirstOrDefault();
            var length = Request.Form["length"].FirstOrDefault();
            var searchValue = Request.Form["search[value]"].FirstOrDefault();

            int pageSize = length != null ? Convert.ToInt32(length) : 0;
            int skip = start != null ? Convert.ToInt32(start) : 0;

            int totalRecords = this.emailService.GetClosedEmailsCount();
            var emails = await this.emailService.ListClosedEmails(skip, pageSize, searchValue);

            var model = emails.Select(x => this.emailMapper.MapFrom(x)).ToList();

            var resultJson = Json(new
            {
                draw = draw,
                recordsFiltered = totalRecords,
                recordsTotal = totalRecords,
                data = model,
                MaxJsonLength = Int32.MaxValue,
            });

            resultJson.SerializerSettings = new Newtonsoft.Json.JsonSerializerSettings
            {
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore
            };

            return resultJson;
        }

        [HttpGet]
        public IActionResult Details(int id)
        {
            var email = this.emailService.GetEmail(id);
            var model = this.emailMapper.MapFrom(email);
            return PartialView("_DetailsPartial", model);
        }

        [HttpGet("404")]
        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

FinalProjectTBI/FinalProjectTBI/Views/ClosedApps/Index.cshtml
@model EmailViewModel

@{
    ViewData["Title"] = "ListClosedEmails";
}

<h2>Closed Applications</h2>
<div id="modal_holder"></div>
<table id="table_id" class="table table-bordered table-condensed">
    <thead class="alert-warning">
        <tr>
            <th>ID</th>
            <th style="width:33%">Subject</th>
            <th style="width:14%">CreatedOn</th>
            <th style="width:20%">Sender</th>
            <th>StatusSetBy</th>
            <th>TimeInCurrentStatus</th>
            <th style="width:10%">Details</th>
        </tr>
    </thead>
    <tfoot class="alert-warning">
        <tr>
            <th>ID</th>
            <th>Subject</th>
            <th>CreatedOn</th>
            <th>Sender</th>
            <th>StatusSetBy</th>
            <th>TimeInCurrentStatus</th>
            <th>Details</th>
        </tr>
    </tfoot>
</table>

<!-- Modal -->
<div class="modal fade" id="myModalNorm" tabindex="-1" role="dialog"
     aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            <!-- Modal Body -->
            <div class="modal-body"></div>
            <!-- Modal Footer -->
            <div class="modal-footer"></div>
        </div>
    </div>
</div>


@section Scripts

    {

    <link rel="stylesheet" type="text/css" href="~/lib/DataTables/datatables.css">
    <script type="text/javascript" language="javascript" src="~/lib/DataTables/datatables.js"></script>
    <script src="~/js/site.js"></script>
    <script type="text/javascript" class="init">

        var table = $('#table_id').DataTable({
            "ordering": false,
            "processing": true,
            "serverSide": true,
            "ajax": {
                "url": "@Url.Action("ListClosedEmails", "ClosedApps")",
                "type": 'POST',
                "dataType": "JSON",
            },

            "columns": [
                { "data": "Id" },
                { "data": "Subject" },
                { "data": "CreatedOn" },
                { "data": "MediatorEmail" },
                { "data": "UserName" },
                { "data": "TimeInCurrentStatus" },
                {
                    "render": function (data, type, email, meta) {
                        return '<button class="details; alert-warning" data-toggle="modal" data-target="#myModalNorm" data-emailid="' + email.Id + '">See more</button>';
                    }
                }
            ]
        });

        $('#myModalNorm').on('shown.bs.modal', function (e) {
            console.log(e);
            var $modal = $(this);
            $body = $modal.find(".modal-body");
            var emailId = $(e.relatedTarget).data('emailid');
            var url = "/ClosedApps/Details/" + emailId;
            $.get(url)
                .done(function (responseData) {
                    $body.html(responseData);
                    $('#New').data('emailId', emailId);
                    $('#Open').data('emailId', emailId);
                    $('#Closed').data('emailId', emailId);
                    $('#NotReviewed').data('emailId', emailId);
                    $('#NotValid').data('emailId', emailId);
                })
        })
    </script>
}